CREATE DATABASE cgl;

USE cgl;

CREATE TABLE approvals (
  id int(11) NOT NULL AUTO_INCREMENT,
  groupid int(11) NOT NULL,
  userid int(11) NOT NULL,
  approvedate timestamp NOT NULL DEFAULT current_timestamp(),
  PRIMARY KEY (id),
  UNIQUE KEY nodups (groupid,userid)
) ENGINE=InnoDB;

CREATE TABLE contracts (
  id int(11) NOT NULL AUTO_INCREMENT,
  groupid int(11) NOT NULL,
  body text NOT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY groupid (groupid)
) ENGINE=InnoDB;

CREATE TABLE groups (
  id int(11) NOT NULL AUTO_INCREMENT,
  groupid int(11) NOT NULL,
  locked tinyint(1) NOT NULL DEFAULT 0,
  PRIMARY KEY (id),
  UNIQUE KEY nodups (groupid)
) ENGINE=InnoDB;

CREATE TABLE roledefs (
  id int(11) NOT NULL AUTO_INCREMENT,
  groupid int(11) NOT NULL,
  name varchar(255) NOT NULL,
  description text NULL,
  weight int(11) NOT NULL,
  PRIMARY KEY (id)
) ENGINE=InnoDB;

CREATE TABLE roles (
  id int(11) NOT NULL AUTO_INCREMENT,
  groupid int(11) NOT NULL,
  roledefid int(11) NOT NULL,
  userid int(11) NOT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY nodups (groupid,roledefid,userid),
  KEY roles_ibfk_1 (roledefid),
  CONSTRAINT roles_ibfk_1 FOREIGN KEY (roledefid) REFERENCES roledefs (id) ON DELETE CASCADE
) ENGINE=InnoDB;

CREATE TABLE stdcontracts (
  id int(11) NOT NULL AUTO_INCREMENT,
  body text NOT NULL,
  created timestamp NOT NULL DEFAULT current_timestamp(),
  PRIMARY KEY (id)
) ENGINE=InnoDB;

CREATE TABLE tokens (
  id int(11) NOT NULL AUTO_INCREMENT,
  userid varchar(40) NOT NULL,
  access varchar(128) NOT NULL,
  created timestamp NOT NULL DEFAULT current_timestamp(),
  refresh varchar(128) NOT NULL,
  tokentype varchar(32) NOT NULL,
  expiry datetime NOT NULL,
  PRIMARY KEY (id),
  UNIQUE KEY nodups (userid)
) ENGINE=InnoDB;

CREATE TABLE verifications (
  id int(11) NOT NULL AUTO_INCREMENT,
  groupid int(11) NOT NULL,
  userid int(11) NOT NULL,
  verifydate timestamp NOT NULL DEFAULT current_timestamp(),
  PRIMARY KEY (id),
  UNIQUE KEY nodups (groupid,userid)
) ENGINE=InnoDB;

