import { Component, ViewChild, Output, EventEmitter } from '@angular/core';

import { NgbModal } from '@ng-bootstrap/ng-bootstrap';

@Component({
  selector: 'app-confirm-delete-modal',
  templateUrl: './confirm-delete-modal.component.html',
  styleUrls: ['./confirm-delete-modal.component.css']
})
export class ConfirmDeleteModalComponent {

  @ViewChild('content', { static: true }) content: any;

  @Output() confirmed: EventEmitter<any> = new EventEmitter();
  @Output() dismissed: EventEmitter<any> = new EventEmitter();

  header: string;
  body: string;
  confirm: string;
  dismiss: string;

  constructor(private modal: NgbModal) {}

  open(header: string, body: string, confirm: string, dismiss: string) {

    this.header = header;
    this.body = body;
    this.confirm = confirm;
    this.dismiss = dismiss;

    this.modal.open(this.content).result.then((result) => {
      this.confirmed.emit();
    }, (reason) => {
      this.dismissed.emit();
     });
  }
}