import { Component, OnInit } from '@angular/core';
import { MessageService } from '../shared/services/message.service';

import { Message, MessageTypes } from '../shared/models/message';

import {
  trigger,
  state,
  style,
  animate,
  transition
} from '@angular/animations';

@Component({
  selector: 'app-messages',
  templateUrl: './messages.component.html',
  styleUrls: ['./messages.component.css'],
  animations: [
    // animation triggers go here

    trigger('simpleFadeAnimation', [

      state('in', style({opacity: 1})),

      transition(':enter', [
        style({opacity: 0}),
        animate('0.6s' )
      ]),

      transition(':leave',
        animate('0.3s', style({opacity: 0})))
    ])
  ]
})
export class MessagesComponent implements OnInit {

  messageTypes = MessageTypes;
  messages: Message[];

  constructor(private messageService: MessageService) {
    this.messages = this.messageService.messages;
  }

  ngOnInit() {
  }

  removeMessage(message: Message): void {
    this.messageService.removeMessage(message);
  }

}
