import {Component, ViewChild, Output, EventEmitter} from '@angular/core';

import {NgbModal } from '@ng-bootstrap/ng-bootstrap';

@Component({
  selector: 'app-save-changes-modal',
  templateUrl: './save-changes-modal.component.html',
  styleUrls: ['./save-changes-modal.component.css']
})
export class SaveChangesModalComponent {

  @ViewChild('content') content: any;

  @Output() yesClicked: EventEmitter<any> = new EventEmitter();
  @Output() noClicked: EventEmitter<any> = new EventEmitter();

  constructor(private modal: NgbModal) {}

  open() {

    this.modal.open(this.content).result.then((result) => {
      if (result === 'yes') {
        this.yesClicked.emit();
      }
      if (result === 'no') {
        this.noClicked.emit();
      }
    }, (reason) => { });
  }
}
